///§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§//*
//             LOW ENERGY MUON SPIN RELAXATION, ROTATION, RADIATION 
// 
//  ID    :LEMuSRElFieldMix.hh , v 1.3
//  AUTHOR: Taofiq PARAISO
//  DATE  : 2005-02-14 15:15
//§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§//
//
//  &           &&&&&&&&&&                            &&&&&&&         &&&&&&&&
//  &           &                                   &&      &&       &       &&
//  &           &                   &      &       &                &       &&
//  &           &&&&&&&            &      &         &&&&&&         &&&&&&&&  
//  &           &                 &      &&                &      &      &&
//  &           &                &&     &  &     &&      &&      &        &
//  &&&&&&&&&&  &&&&&&&&&&      &  &&&&&    &&    &&&&&&&       &        &&   
//                             &
//                            &
//                           &
//                         &  
//                               Electric Field  MIX
//§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§//

#ifndef LEMUSRELECTRICFIELDMIX_H
#define LEMUSRELECTRICFIELDMIX_H 1
 
#include"G4ElectricField.hh"
#include"G4ElectroMagneticField.hh"
#include "globals.hh"
#include "G4ios.hh"

#include <iomanip.h>
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include "CLHEP/Matrix/Vector.h"
#include "CLHEP/Matrix/Matrix.h"


#include "LEMuSRElectricField.hh"

class LEMuSRElFieldMix : public G4ElectricField
{
public:
 

  LEMuSRElFieldMix( LEMuSRElectricField* E1,  LEMuSRElectricField* E2,  G4double field1_val, G4double field2_val);

  LEMuSRElFieldMix( G4ElectricField* E1,  G4ElectricField* E2,  G4double field1_val, G4double field2_val);
  


  
  ~LEMuSRElFieldMix();
  
  void GetFieldValue(const G4double point[4], G4double *Bfield) const;
  
  void Test();
  
public:
  G4double coef1, coef2;
  // LEMuSRElectricField* field1, *field2;
  G4ElectricField* field1, *field2;

  
};

#endif


