//	History
//        first version                   12 Nov. 2000 by H.Kurashige 
// ------------------------------------------------------------
#ifndef LEMuSRGeneralPhysics_h
#define LEMuSRGeneralPhysics_h 1

#include "globals.hh"
#include "G4ios.hh"

#include "G4VPhysicsConstructor.hh"
#include "G4StepLimiter.hh"

#include "LEMuSRDecay.hh"

class LEMuSRGeneralPhysics : public G4VPhysicsConstructor
{
public: 
  LEMuSRGeneralPhysics(const G4String& name = "general");
  virtual ~LEMuSRGeneralPhysics();
  
public: 
  // This method will be invoked in the Construct() method. 
  // each particle type will be instantiated
  virtual void ConstructParticle();
  
  // This method will be invoked in the Construct() method.
  // each physics process will be instantiated and
  // registered to the process manager of each particle type 
  virtual void ConstructProcess();
  
protected:
  LEMuSRDecay fDecayProcess;
  G4StepLimiter fStepLimiter;
};


#endif








  
